<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>WebConfigurer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Test App J Hipster</a> &gt; <a href="index.source.html" class="el_package">com.theo.myjhipster.config</a> &gt; <span class="el_source">WebConfigurer.java</span></div><h1>WebConfigurer.java</h1><pre class="source lang-java linenums">package com.theo.myjhipster.config;

import io.github.jhipster.config.JHipsterConstants;
import io.github.jhipster.config.JHipsterProperties;
import io.github.jhipster.config.h2.H2ConfigurationHelper;
import io.github.jhipster.web.filter.CachingHttpHeadersFilter;
import io.undertow.UndertowOptions;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.embedded.undertow.UndertowServletWebServerFactory;
import org.springframework.boot.web.server.*;
import org.springframework.boot.web.servlet.ServletContextInitializer;
import org.springframework.boot.web.servlet.server.ConfigurableServletWebServerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.http.MediaType;
import org.springframework.web.cors.CorsConfiguration;
import org.springframework.web.cors.UrlBasedCorsConfigurationSource;
import org.springframework.web.filter.CorsFilter;

import javax.servlet.*;
import java.io.File;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Paths;
import java.util.*;

import static java.net.URLDecoder.decode;

/**
 * Configuration of web application with Servlet 3.0 APIs.
 */
@Configuration
public class WebConfigurer implements ServletContextInitializer, WebServerFactoryCustomizer&lt;WebServerFactory&gt; {

<span class="fc" id="L38">    private final Logger log = LoggerFactory.getLogger(WebConfigurer.class);</span>

    private final Environment env;

    private final JHipsterProperties jHipsterProperties;

<span class="fc" id="L44">    public WebConfigurer(Environment env, JHipsterProperties jHipsterProperties) {</span>

<span class="fc" id="L46">        this.env = env;</span>
<span class="fc" id="L47">        this.jHipsterProperties = jHipsterProperties;</span>
<span class="fc" id="L48">    }</span>

    @Override
    public void onStartup(ServletContext servletContext) throws ServletException {
<span class="pc bpc" id="L52" title="1 of 2 branches missed.">        if (env.getActiveProfiles().length != 0) {</span>
<span class="fc" id="L53">            log.info(&quot;Web application configuration, using profiles: {}&quot;, (Object[]) env.getActiveProfiles());</span>
        }
<span class="fc" id="L55">        EnumSet&lt;DispatcherType&gt; disps = EnumSet.of(DispatcherType.REQUEST, DispatcherType.FORWARD, DispatcherType.ASYNC);</span>
<span class="fc bfc" id="L56" title="All 2 branches covered.">        if (env.acceptsProfiles(JHipsterConstants.SPRING_PROFILE_PRODUCTION)) {</span>
<span class="fc" id="L57">            initCachingHttpHeadersFilter(servletContext, disps);</span>
        }
<span class="fc bfc" id="L59" title="All 2 branches covered.">        if (env.acceptsProfiles(JHipsterConstants.SPRING_PROFILE_DEVELOPMENT)) {</span>
<span class="fc" id="L60">            initH2Console(servletContext);</span>
        }
<span class="fc" id="L62">        log.info(&quot;Web application fully configured&quot;);</span>
<span class="fc" id="L63">    }</span>

    /**
     * Customize the Servlet engine: Mime types, the document root, the cache.
     */
    @Override
    public void customize(WebServerFactory server) {
<span class="fc" id="L70">        setMimeMappings(server);</span>
        // When running in an IDE or with ./mvnw spring-boot:run, set location of the static web assets.
<span class="fc" id="L72">        setLocationForStaticAssets(server);</span>

        /*
         * Enable HTTP/2 for Undertow - https://twitter.com/ankinson/status/829256167700492288
         * HTTP/2 requires HTTPS, so HTTP requests will fallback to HTTP/1.1.
         * See the JHipsterProperties class and your application-*.yml configuration files
         * for more information.
         */
<span class="pc bpc" id="L80" title="1 of 4 branches missed.">        if (jHipsterProperties.getHttp().getVersion().equals(JHipsterProperties.Http.Version.V_2_0) &amp;&amp;</span>
            server instanceof UndertowServletWebServerFactory) {

<span class="fc" id="L83">            ((UndertowServletWebServerFactory) server)</span>
<span class="fc" id="L84">                .addBuilderCustomizers(builder -&gt;</span>
<span class="fc" id="L85">                    builder.setServerOption(UndertowOptions.ENABLE_HTTP2, true));</span>
        }
<span class="fc" id="L87">    }</span>

    private void setMimeMappings(WebServerFactory server) {
<span class="pc bpc" id="L90" title="1 of 2 branches missed.">        if (server instanceof ConfigurableServletWebServerFactory) {</span>
<span class="fc" id="L91">            MimeMappings mappings = new MimeMappings(MimeMappings.DEFAULT);</span>
            // IE issue, see https://github.com/jhipster/generator-jhipster/pull/711
<span class="fc" id="L93">            mappings.add(&quot;html&quot;, MediaType.TEXT_HTML_VALUE + &quot;;charset=&quot; + StandardCharsets.UTF_8.name().toLowerCase());</span>
            // CloudFoundry issue, see https://github.com/cloudfoundry/gorouter/issues/64
<span class="fc" id="L95">            mappings.add(&quot;json&quot;, MediaType.TEXT_HTML_VALUE + &quot;;charset=&quot; + StandardCharsets.UTF_8.name().toLowerCase());</span>
<span class="fc" id="L96">            ConfigurableServletWebServerFactory servletWebServer = (ConfigurableServletWebServerFactory) server;</span>
<span class="fc" id="L97">            servletWebServer.setMimeMappings(mappings);</span>
        }
<span class="fc" id="L99">    }</span>

    private void setLocationForStaticAssets(WebServerFactory server) {
<span class="pc bpc" id="L102" title="1 of 2 branches missed.">        if (server instanceof ConfigurableServletWebServerFactory) {</span>
<span class="fc" id="L103">            ConfigurableServletWebServerFactory servletWebServer = (ConfigurableServletWebServerFactory) server;</span>
            File root;
<span class="fc" id="L105">            String prefixPath = resolvePathPrefix();</span>
<span class="fc" id="L106">            root = new File(prefixPath + &quot;target/www/&quot;);</span>
<span class="pc bpc" id="L107" title="2 of 4 branches missed.">            if (root.exists() &amp;&amp; root.isDirectory()) {</span>
<span class="fc" id="L108">                servletWebServer.setDocumentRoot(root);</span>
            }
        }
<span class="fc" id="L111">    }</span>

    /**
     * Resolve path prefix to static resources.
     */
    private String resolvePathPrefix() {
        String fullExecutablePath;
        try {
<span class="fc" id="L119">            fullExecutablePath = decode(this.getClass().getResource(&quot;&quot;).getPath(), StandardCharsets.UTF_8.name());</span>
<span class="nc" id="L120">        } catch (UnsupportedEncodingException e) {</span>
            /* try without decoding if this ever happens */
<span class="nc" id="L122">            fullExecutablePath = this.getClass().getResource(&quot;&quot;).getPath();</span>
<span class="fc" id="L123">        }</span>
<span class="fc" id="L124">        String rootPath = Paths.get(&quot;.&quot;).toUri().normalize().getPath();</span>
<span class="fc" id="L125">        String extractedPath = fullExecutablePath.replace(rootPath, &quot;&quot;);</span>
<span class="fc" id="L126">        int extractionEndIndex = extractedPath.indexOf(&quot;target/&quot;);</span>
<span class="pc bpc" id="L127" title="1 of 2 branches missed.">        if (extractionEndIndex &lt;= 0) {</span>
<span class="fc" id="L128">            return &quot;&quot;;</span>
        }
<span class="nc" id="L130">        return extractedPath.substring(0, extractionEndIndex);</span>
    }

    /**
     * Initializes the caching HTTP Headers Filter.
     */
    private void initCachingHttpHeadersFilter(ServletContext servletContext,
                                              EnumSet&lt;DispatcherType&gt; disps) {
<span class="fc" id="L138">        log.debug(&quot;Registering Caching HTTP Headers Filter&quot;);</span>
<span class="fc" id="L139">        FilterRegistration.Dynamic cachingHttpHeadersFilter =</span>
<span class="fc" id="L140">            servletContext.addFilter(&quot;cachingHttpHeadersFilter&quot;,</span>
                new CachingHttpHeadersFilter(jHipsterProperties));

<span class="fc" id="L143">        cachingHttpHeadersFilter.addMappingForUrlPatterns(disps, true, &quot;/i18n/*&quot;);</span>
<span class="fc" id="L144">        cachingHttpHeadersFilter.addMappingForUrlPatterns(disps, true, &quot;/content/*&quot;);</span>
<span class="fc" id="L145">        cachingHttpHeadersFilter.addMappingForUrlPatterns(disps, true, &quot;/app/*&quot;);</span>
<span class="fc" id="L146">        cachingHttpHeadersFilter.setAsyncSupported(true);</span>
<span class="fc" id="L147">    }</span>

    @Bean
    public CorsFilter corsFilter() {
<span class="fc" id="L151">        UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();</span>
<span class="fc" id="L152">        CorsConfiguration config = jHipsterProperties.getCors();</span>
<span class="fc bfc" id="L153" title="All 4 branches covered.">        if (config.getAllowedOrigins() != null &amp;&amp; !config.getAllowedOrigins().isEmpty()) {</span>
<span class="fc" id="L154">            log.debug(&quot;Registering CORS filter&quot;);</span>
<span class="fc" id="L155">            source.registerCorsConfiguration(&quot;/api/**&quot;, config);</span>
<span class="fc" id="L156">            source.registerCorsConfiguration(&quot;/management/**&quot;, config);</span>
<span class="fc" id="L157">            source.registerCorsConfiguration(&quot;/v2/api-docs&quot;, config);</span>
        }
<span class="fc" id="L159">        return new CorsFilter(source);</span>
    }

    /**
     * Initializes H2 console.
     */
    private void initH2Console(ServletContext servletContext) {
<span class="fc" id="L166">        log.debug(&quot;Initialize H2 console&quot;);</span>
<span class="fc" id="L167">        H2ConfigurationHelper.initH2Console(servletContext);</span>
<span class="fc" id="L168">    }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.2.201808211720</span></div></body></html>